const Discord = require('discord.js');
const client = new Discord.Client();
const settings = require('./settings.json');
const sprintf = require('sprintf-js').sprintf;
const vsprintf = require('sprintf-js').vsprintf;
const sqlite3 = require('sqlite3').verbose();

const file = "/Users/tford/bot/botRepLevel/data.db";
const dbData = new sqlite3.Database(file);


// 206... is my user id, from right-click, get user id.
const ownerID = '206757095280869377';

const cmdChars = "\."; // backslash escapes period in regexp
const scoreTimeDelay = 60000; // 60 seconds, in milliseconds
const reputationTimeDelay = 60000 * 60 * 24; // 1 day

const scoreRequiredToLevel = 5;

client.on('ready',() => {
	console.log("online");
});

// scrubs strings before letting them into the database
function insertScrub(str,len) {
	if (!str) return "";
	if (str === "") return "";
	var newStr = str.replace(/\'/g,"");
	newStr = newStr.replace(/\"/g,"");
	newStr = newStr.replace(/\`/g,"");
	newStr = newStr.replace(/\;/g,"");
	newStr = newStr.replace(/\&/g,"");
	if (newStr.length > len) { // cut to fit in database field
		newStr = newStr.substring(1,(len-1));
	}
	return newStr;
}

function nowString(){
	var d = new Date();
	var whenString = d.getFullYear() + "-";
	whenString += sprintf("%1$2s",(d.getMonth()+1)) + "-";
	whenString += sprintf("%1$2s",d.getDate()) + "-";
	whenString += sprintf("%1$2s",d.getHours()) + ":";
	whenString += sprintf("%1$2s",d.getMinutes());
	whenString = whenString.replace(/\ /g,"0");
	return whenString;
}

// Returns 1 if user_id has role_name
function hasRoleByName(message, user_id, role_name) { 
	if (!message || !user_id || !role_name) {
		console.log("check arguments to hasRoleByName");
		return null;
	}
	var member = message.guild.members.cache.find(user => user.id === user_id);
	if (!member) { return 0; }
	var role = member.roles.cache.find(role => role.name === role_name);
	if (role) { return 1; } else { return 0; }
}

// Returns the nickname, if available, or the username.
function getNickname(client, message, user_id) {
	if (!client || !message || !user_id) {
		console.log("check arguments to getNickname");
		return null;
	}

	var user = client.users.cache.find(user => user.id === user_id);
	var username = user.username;

	if (username == null || username == "") {
		username = "<@" + user_id + ">";
	}

	username = username.replace(/\'/g,"");
	username = username.replace(/\"/g,"");
	username = username.replace(/\;/g,"");
	username = username.replace(/\&/g,"");

	if (message.guild == null) { return username; }

	var member = message.guild.members.cache.find(user => user.id === user_id);

	var nickname = member.nickname;

	if (nickname == null) { return username; }

	nickname = nickname.replace(/\'/g,"");
	nickname = nickname.replace(/\"/g,"");
	nickname = nickname.replace(/\;/g,"");
	nickname = nickname.replace(/\&/g,"");

	return nickname;
}

function addPerson(message, user_id) {
	var sql = "";
	sql += "INSERT INTO tblUsers( ";
		sql += "txtID, ";
		sql += "txtNickname ";
	sql += ") VALUES ( ";
		sql += "'" + insertScrub(user_id,25) + "', ";
		sql += "'" + insertScrub(getNickname(client, message, user_id)) + "' ";
	sql += ");"

	// This will fail if the record exists
	// but we really don't care.
	// This just makes sure their record is in the database.
	return dbData.run(sql, [], function(err) {
		if (err) {
			//console.log(sql);
			//return console.log(err.message);
			return 0;
		}
		//console.log(`Row(s) updated: ${this.changes}`);
		return 1;
		});
}


// createdTimestamp = ms since epoc
// { id: message.author.id, when: message.createdTimestamp }
var lastScoredMessage = [];

function addScore(msg) {
	if (!msg) return;
	console.log(msg.author.id + " has gained Score.");
	// update database
	var x = addPerson(msg, msg.author.id);

	var sql = "";
	sql += "UPDATE tblUsers ";
	sql += "SET "
		sql += "txtNickname = '" + insertScrub(getNickname(client, msg, msg.author.id)) + "', ";
		sql += "intScore = (intScore + 1) ";
	sql += "WHERE ";
		sql += "txtID = '" + insertScrub(msg.author.id,25) + "' ";
	sql += ";";

	dbData.run(sql, [], function(err) {
		if (err) {
			console.log(sql);
			console.log(err.message);
		}

		//console.log(`Row(s) updated: ${this.changes}`);

		// Finished running the update.

		// Query the data to find if we need to update and announce the level.

		sql = "SELECT * ";
		sql += "FROM tblUSERS ";
		sql += "WHERE ";
			sql += "txtID = '" + insertScrub(msg.author.id,25) + "' ";
		sql += ";";

		dbData.all(sql, function(err, rows) {

			if (err) {
				console.log(sql);
				console.log(err.message);
			}

			// This only returns 1 row (unique by ID).
			var score = rows[0].intScore;
			var level = rows[0].intLevel; // grab for use later.

			if (score >= scoreRequiredToLevel) {
			
				// Update the level.
				sql = "UPDATE tblUsers ";
				sql += "SET "
					sql += "intLevel = (intLevel + 1), ";
					sql += "intScore = 0 ";
				sql += "WHERE ";
					sql += "txtID = '" + insertScrub(msg.author.id,25) + "' ";
				sql += ";";

				dbData.run(sql, [], function(err) {
					if (err) {
						console.log(sql);
						console.log(err);
					}
					
					var str = "";
					str += "<@" + msg.author.id + "> is now Level " + (level + 1) + ".";
					msg.channel.send(str);

				}); // end update intLevel = intLevel + 1
			}

		}); // end get intScore

	}); // end update intScore = intScore + 1


} // end function addScore(msg)

function removeScoredMessage(user_id) {
	if (!user_id) return;
	lastScoredMessage = lastScoredMessage.filter(function(a) {
		return a.id != user_id;
	});
	//console.log("removed: " + user_id);
	//console.log(lastScoredMessage);
}

function addScoredMessage(msg) {
	if (!msg) return;
	var arr = { id: msg.author.id, when: msg.createdTimestamp };
	lastScoredMessage.push(arr);
	//console.log("added: " + msg.author.id);
	//console.log(lastScoredMessage);
}

client.on('message', message => {

	if (message.author === client.user) return;
	if (message.author.bot) return;

	//console.log(message.author.id + ":" + message.author.username);
	//console.log(message.content);


		if (message.content == (cmdChars + "configure") ) {
			if (message.author.id != ownerID) { return; }
			// create the table
			var sql = "CREATE TABLE IF NOT EXISTS tblUsers( ";
			sql += "txtID CHAR(25) PRIMARY KEY NOT NULL, ";
			sql += "intLastGaveRepOn INTEGER DEFAULT 0, ";
			sql += "intScore INTEGER DEFAULT 0, ";
			sql += "intLevel INTEGER DEFAULT 0, ";
			sql += "intReputation INTEGER DEFAULT 0, ";
			sql += "txtNickname VARCHAR DEFAULT '' ";
			sql += ");";
			dbData.run(sql);
			message.channel.send("Database created.");
			return;
		}


	// ************************************************************
	// Count posts

	//console.log(message.author.id);
	//console.log(message.createdTimestamp);

	var filtered = lastScoredMessage.filter(function(a) {
		return a.id == message.author.id;
	});	

	//console.log(lastScoredMessage);
	//console.log(filtered);

	// user has already posted something, find how long ago
	if ( filtered.length > 0 ) {
		// this createdTimestamp - last createdTimestamp = ms since last message
		if ( (message.createdTimestamp - filtered[0].when) > scoreTimeDelay ) {
			addScore(message);
			removeScoredMessage(message.author.id);
			addScoredMessage(message);			
		}
		// keeps old record
	// no messages since bot start, give them score
	} else {	
		addScore(message);
		addScoredMessage(message);			
	}

	// ************************************************************
	// Help and Reputation

	if (message.content.startsWith(cmdChars)) {

		// ^ start
		// . any character except line breaks
		// * 0 or more times
		// ()'s group capture
		// $ end of line
		var regex = new RegExp("^" + cmdChars + "(.*)$");	

		var strMessage = message.content;
		var result = strMessage.match(regex);
		if (!result) {
			return;
		}	
		//console.log(result);

		var cmd = result[1];

		//console.log(cmd);

		if (cmd == "help rep") {
			var str = "";
			str += "Sir Rep Level supports these commands:\n";
			str += "\t" + cmdChars + "rep @name\n";
			str += "\t" + cmdChars + "level [optional @name]\n";
			str += "\t" + cmdChars + "top\n";
			str += "\n";
			str += "\tAdmins Only:\n";
			str += "\tadjust rep @name [amount]\n";
			str += "\tadjust score @name [amount]\n";
			str += "\treset all rep\n";
			str += "\treset all level\n";
			str += "\tconfigure\n";
			str += "\n";
			str += "Bot by ";
			// 206... is my user id, from right-click, get user id.
			str += getNickname(client, message,'206757095280869377');
			// the < > prevents a website preview from being shown.
			str += ", <http://www.Cattail.Nu>\n";
			message.channel.send(str);
		}

		if (cmd.startsWith("level")) {
			var who = message.author.id;
			var user = message.mentions.users.first();
			if (user) {
				who = user.id;
			}

			var x = addPerson(message, who);

			var sql = "SELECT * ";
			sql += "FROM tblUSERS ";
			sql += "WHERE ";
				sql += "txtID = '" + insertScrub(who,25) + "' ";
			sql += ";";

			dbData.all(sql, function(err, rows) {

				if (err) {
					console.log(sql);
					console.log(err.message);
				}

				var str = "";
					str += "<@" + rows[0].txtID + ">\n";
					str += " Level: " + rows[0].intLevel + "\n";				
					str += " Reputation: " + rows[0].intReputation + "\n";
				message.channel.send(str);

			});

		} //end cmd.startsWith("level")

		if (cmd == "top") {
			var sql = "SELECT * ";
			sql += "FROM tblUSERS ";
			sql += "ORDER BY "; 
				sql += "intReputation DESC, ";
				sql += "txtNickname ";
			sql += "LIMIT 10 ";
			sql += ";";

			var str = "";
			str += "Top People:\n";

			dbData.all(sql, function(err, rows) {

				if (err) {
					console.log(sql);
					console.log(err.message);
				}

				for (var i=0; i < rows.length; i++) {
					str += "Reputation " + rows[i].intLevel + ": " + rows[i].txtNickname + "\n";
				}

				str += "\n";

				sql = "SELECT * ";
				sql += "FROM tblUSERS ";
				sql += "ORDER BY "; 
					sql += "intLevel DESC, ";
					sql += "txtNickname ";
				sql += "LIMIT 10 ";
				sql += ";";

				dbData.all(sql, function(err, rows) {

					if (err) {
						console.log(sql);
						console.log(err.message);
					}

					for (i=0; i < rows.length; i++) {
						str += "Level " + rows[i].intLevel + ": " + rows[i].txtNickname + "\n";
					}

					message.channel.send(str);
				}); // level

			}); // reputation

		} //end cmd == "top"


		if (cmd.startsWith("rep ")) {
			var user = message.mentions.users.first();
			if (!user) {
				message.channel.send("Give reputation to whom?");
				return;
			}
			//console.log(user);

			if (message.author.id == user.id) {
				message.channel.send("Nice try!");
				return;
			}

			// make sure giver and receiver are in the database
			var x = addPerson(message, message.author.id);
			var y = addPerson(message, user.id);

			var userNickname = insertScrub(getNickname(client, message,user.id));
			var authorNickname = insertScrub(getNickname(client, message,message.author.id));

			// get the giver and see if he/she is able to give rep
			var sql = "SELECT * ";
			sql += "FROM tblUSERS ";
			sql += "WHERE ";
				sql += "txtID = '" + insertScrub(message.author.id,25) + "' ";
			sql += ";";

			dbData.all(sql, function(err, rows) {

				if (err) {
					console.log(sql);
					console.log(err.message);
				}

				var intLastGaveRepOn = rows[0].intLastGaveRepOn;

				if ( (message.createdTimestamp - rows[0].intLastGaveRepOn) < reputationTimeDelay) {
					message.channel.send("You are not able to award more reputation yet.");
					return;
				}

				sql = "UPDATE tblUsers ";
				sql += "SET "
					sql += "txtNickname = '" + userNickname + "', ";
					sql += "intReputation = (intReputation + 1) ";
				sql += "WHERE ";
					sql += "txtID = '" + insertScrub(user.id,25) + "' ";
				sql += ";";

				dbData.run(sql, [], function(err) {
					if (err) {
						console.log(sql);
						console.log(err);
					}
				
					var str = "";
					str += "<@" + user.id + "> has been awarded Reputation by <@" + message.author.id + ">.";
					message.channel.send(str);

					console.log(nowString() + ":" + message.author.id + " Rep To " + user.id + " (" + authorNickname + " to " + userNickname + ")");

					sql = "UPDATE tblUsers ";
					sql += "SET "
						sql += "txtNickname = '" + authorNickname + "', ";
						sql += "intLastGaveRepOn = " + message.createdTimestamp + " ";
					sql += "WHERE ";
						sql += "txtID = '" + insertScrub(message.author.id,25) + "' ";
					sql += ";";

					dbData.run(sql, [], function(err) {
						if (err) {
							console.log(sql);
							console.log(err);
						}
					});

				}); // end add Reputation


			}); // is the person allowed to award more reputation?


		} // if (cmd.startsWith("rep "))

		if (cmd == "reset all rep") {
			// only me.
			if (message.author.id != ownerID ) { return; }
			// Admins only.
			//if ( !hasRoleByName(message, message.author.id, "Admin") ) { return; }

			// set all level to 0
			// set all score to 0
			var sql = "UPDATE tblUsers ";
			sql += "SET "
				sql += "intReputation = 0 ";
			sql += ";";

			dbData.run(sql, [], function(err) {
				if (err) {
					console.log(sql);
					console.log(err);
				}
				
				var str = "";
				str += "Everyone's reputation is now 0.";
				message.channel.send(str);

			}); // end reset all rep
			
		} // end if (cmd == "reset all rep")

		if (cmd == "reset all level") {
			// only me.
			if (message.author.id != ownerID ) { return; }
			// Admins only.
			//if ( !hasRoleByName(message, message.author.id, "Admin") ) { return; }
			
			// set all level to 0
			// set all score to 0
			var sql = "UPDATE tblUsers ";
			sql += "SET "
				sql += "intLevel = 0, ";
				sql += "intScore = 0 ";
			sql += ";";

			dbData.run(sql, [], function(err) {
				if (err) {
					console.log(sql);
					console.log(err);
				}
				
				var str = "";
				str += "Everyone's score and level are now 0.";
				message.channel.send(str);

			}); // end reset all levels, scores

		} // end if (cmd == "reset all level")


		if (cmd.startsWith("adjust score ")) {
			// only me.
			if (message.author.id != ownerID ) { return; }
			// Admins only.
			//if ( !hasRoleByName(message, message.author.id, "Admin") ) { return; }

			//console.log(cmd);
			regex = new RegExp("^adjust score <@!([0-9]*)> ([+-]*[0-9]+)");	
			result = cmd.match(regex);
			if (!result) {
				message.channel.send("Bad syntax.");
				return;
			}	
			//console.log(result);
			//console.log(result.length);
			if (!(result.length == 3)) {
				message.channel.send("Bad syntax.");
				return;
			}

			var who = result[1];
			var adjustment = result[2];

			var sql = "UPDATE tblUsers ";
			sql += "SET "
				sql += "intScore = intScore + " + adjustment + " ";
			sql += "WHERE ";
				sql += "txtID = '" + who + "' ";
			sql += ";";

			dbData.run(sql, [], function(err) {
				if (err) {
					console.log(sql);
					console.log(err);
				}
				
				var str = "";
				str += "<@" + who + ">'s score has been adjusted.";
				message.channel.send(str);

			}); // end adjust intScore

		} // end if (cmd.startsWith("adjust score "))

		if (cmd.startsWith("adjust rep ")) {
			// only me.
			if (message.author.id != ownerID ) { return; }
			// Admins only.
			//if ( !hasRoleByName(message, message.author.id, "Admin") ) { return; }

			//console.log(cmd);
			regex = new RegExp("^adjust rep <@!([0-9]*)> ([+-]*[0-9]+)");	
			result = cmd.match(regex);
			if (!result) {
				message.channel.send("Bad syntax.");
				return;
			}	
			//console.log(result);
			//console.log(result.length);
			if (!(result.length == 3)) {
				message.channel.send("Bad syntax.");
				return;
			}

			var who = result[1];
			var adjustment = result[2];

			var sql = "UPDATE tblUsers ";
			sql += "SET "
				sql += "intReputation = intReputation + " + adjustment + " ";
			sql += "WHERE ";
				sql += "txtID = '" + who + "' ";
			sql += ";";

			dbData.run(sql, [], function(err) {
				if (err) {
					console.log(sql);
					console.log(err);
				}
				
				var str = "";
				str += "<@" + who + ">'s score has been adjusted.";
				message.channel.send(str);

			}); // end adjust intReputation

		} // end if (cmd.startsWith("adjust rep "))
	
	} // end if (message.content.startsWith(cmdChars))


}); // end client.on

/*
// If they leave and come back, do we want them to start over?
client.on("guildMemberRemove", (member) => {
	// remove person from database
});
*/

client.on('error', function (err) {
  console.log('Global error handler called:\n');
  if(err) {console.log(err);}
});

client.login(settings.token);

